Subject: Re: [Q/RFC] BPF use in broader scope

From: Jiri Pirko <[email-masked]>
Date: Thu, 29 Mar 2012 09:54:10 +0200

Thu, Mar 29, 2012 at 09:49:57AM CEST, [email-masked] wrote:
>From: Jiri Pirko <[email-masked]>
>Date: Thu, 29 Mar 2012 09:44:43 +0200
>
>> Here are proposed things to be done:
>> 1) introduce in-kernel api for creating sk-unattached filters (I have
>>    the patch cooked up already)
>> 
>> 2) extend current BPF machine to allow XOR operation. Not sure if this
>>    is doable or what the best of doing this is.
>> 
>> 3) add possibility to pass some data to the machine via
>>    pre-filling "Scratch Memory Store". I think this can be done easily
>>    moving "u32 mem[BPF_MEMWORDS];" to bpf_func caller and pass it as the
>>    second function parameter. That should not break anything.
>> 
>> Then the computed hash can be either stored into Scratch memory or returned
>> directly (where ordinary sk filters return len).
>> 
>> Does this seems reasonable? Thoughts, comments?
>
>No fundamental objections, but we have all of these JITs now to
>update when adding new operations or semantics, so be careful.

Yep, I'm aware. I must admit that the JIT code scares me a litte :(